var __defProp = Object.defineProperty;
var __defNormalProp = (obj, key, value) => key in obj ? __defProp(obj, key, { enumerable: true, configurable: true, writable: true, value }) : obj[key] = value;
var __publicField = (obj, key, value) => {
  __defNormalProp(obj, typeof key !== "symbol" ? key + "" : key, value);
  return value;
};
var index = "";
const icon = '<svg xmlns="http://www.w3.org/2000/svg" height="20px" viewBox="0 0 24 24" width="20px" class=".codex-editor"><path d="M0 0h24v24H0z" fill="none"/><path d="M3 9v6h4l5 5V4L7 9H3zm13.5 3c0-1.77-1.02-3.29-2.5-4.03v8.05c1.48-.73 2.5-2.25 2.5-4.02zM14 3.23v2.06c2.89.86 5 3.54 5 6.71s-2.11 5.85-5 6.71v2.06c4.01-.91 7-4.49 7-8.77s-2.99-7.86-7-8.77z"/></svg>';
class AudioEditor {
  constructor({ data, config, api, block, readOnly }) {
    __publicField(this, "_initUploadElement", () => {
      const uploadButton = document.createElement("input");
      uploadButton.setAttribute("type", "file");
      uploadButton.setAttribute("accept", this.config.types);
      uploadButton.onchange = this._updateUrl;
      this.uploadButton = uploadButton;
    });
    __publicField(this, "_updateUrl", async () => {
      const file = this.uploadButton.files[0];
      const { type } = file;
      this.button.parentNode.classList.add("editerjs-audio-loading", this.api.styles.loader);
      let body = new FormData();
      body.append(this.config.field, file);
      let request = {
        method: "POST",
        body
      };
      if (this.config.requestParser !== null) {
        request = this.config.requestParser(request, this.block);
      }
      let respond = await fetch(this.config.endpointUrl, request);
      if (this.config.respondParser !== null) {
        this.api.blocks.update(this.block.id, {
          url: await this.config.respondParser(respond, this.block),
          type
        });
      } else {
        let url = (await respond.json()).url;
        this.api.blocks.update(this.block.id, { url, type });
      }
    });
    __publicField(this, "_createUploadButton", () => {
      const button = document.createElement("div");
      button.classList.add("cdx-button");
      button.innerHTML = this.config.buttonContent || `${icon} ${this.api.i18n.t("Select an Audio")}`;
      button.onclick = () => {
        this.uploadButton.click();
      };
      this.button = button;
      return button;
    });
    __publicField(this, "_createAudioPlayer", () => {
      const player = document.createElement("audio");
      const source = document.createElement("source");
      player.setAttribute("controls", "");
      if (!this.config.downloadable) {
        player.setAttribute("controlsList", "nodownload");
      }
      player.classList.add("editerjs-audio-conent__audio-player");
      source.setAttribute("src", this.data.url);
      source.setAttribute("type", this.data.type);
      player.appendChild(source);
      return player;
    });
    __publicField(this, "render", () => {
      if (this.readOnly) {
        if (typeof this.data.url !== "string") {
          return this._createAudioUrlInvalidAlert();
        } else {
          return this._createAudioPlayer();
        }
      } else {
        if (typeof this.data.url !== "string") {
          this.uploadButton.click();
          return this._createUploadButton();
        } else {
          return this._createAudioPlayer();
        }
      }
    });
    this.readOnly = readOnly;
    this.config = {
      endpointUrl: config.endpointUrl || null,
      dowloadable: config.dowloadable || false,
      requestParser: config.requestParser || null,
      respondParser: config.respondParser || null,
      field: config.field || "file",
      types: config.types || "audio/*",
      onDelete: config.onDelete || null
    };
    this.data = {
      url: data.url || null,
      type: data.type || null
    };
    this.api = api;
    this.block = block;
    this._initUploadElement();
  }
  static get isReadOnlySupported() {
    return true;
  }
  static get toolbox() {
    return {
      title: "Audio",
      icon
    };
  }
  _createAudioUrlInvalidAlert() {
    const button = document.createElement("div");
    button.classList.add("cdx-button");
    button.innerHTML = `${this.api.i18n.t("Audio url file is invalid")}`;
    return button;
  }
  removed() {
    if (this.config.onDelete !== null) {
      this.config.onDelete(this.block);
    }
  }
  save() {
    return this.data;
  }
}
export { AudioEditor as default };
